Index: /trunk/src/VBox/Main/src-global/win/VBoxSDS.cpp
===================================================================
--- /trunk/src/VBox/Main/src-global/win/VBoxSDS.cpp	(revision 98052)
+++ /trunk/src/VBox/Main/src-global/win/VBoxSDS.cpp	(revision 98053)
@@ -352,6 +352,6 @@
         uint32_t const uPrevState = ASMAtomicXchgU32((uint32_t volatile *)&m_Status.dwCurrentState, dwState);
         if (!::SetServiceStatus(m_hServiceStatus, &m_Status))
-            LogRel(("Error: SetServiceStatus(%p, %u) failed: %u (uPrevState=%u)\n",
-                    m_hServiceStatus, dwState, GetLastError(), uPrevState));
+            LogRel(("Error: SetServiceStatus(%u) failed: %u (uPrevState=%u)\n",
+                    dwState, GetLastError(), uPrevState));
     }
 
@@ -1031,5 +1031,4 @@
                 LogRelFunc(("VBoxSDS: new CComServiceModule::Init failed: %Rhrc\n", hrcExit));
 
-            LogRelFunc(("VBoxSDS: deleting pServiceModule (%p)\n", pServiceModule));
             delete pServiceModule;
             pServiceModule = NULL;
Index: /trunk/src/VBox/Main/src-global/win/VirtualBoxSDSImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/src-global/win/VirtualBoxSDSImpl.cpp	(revision 98052)
+++ /trunk/src/VBox/Main/src-global/win/VirtualBoxSDSImpl.cpp	(revision 98053)
@@ -266,5 +266,5 @@
 STDMETHODIMP VirtualBoxSDS::RegisterVBoxSVC(IVBoxSVCRegistration *aVBoxSVC, LONG aPid, IUnknown **aExistingVirtualBox)
 {
-    LogRel(("registerVBoxSVC: aVBoxSVC=%p aPid=%u (%#x)\n", (IVBoxSVCRegistration *)aVBoxSVC, aPid, aPid));
+    LogRel(("registerVBoxSVC: aPid=%u (%#x)\n", aPid, aPid));
 
     /*
@@ -514,5 +514,5 @@
         hrc = E_INVALIDARG;
     }
-    LogRel2(("VirtualBoxSDS::registerVBoxSVC: returns %Rhrc aExistingVirtualBox=%p\n", hrc, (IUnknown *)aExistingVirtualBox));
+    LogRel2(("VirtualBoxSDS::registerVBoxSVC: returns %Rhrc\n", hrc));
     return hrc;
 }
@@ -521,5 +521,5 @@
 STDMETHODIMP VirtualBoxSDS::DeregisterVBoxSVC(IVBoxSVCRegistration *aVBoxSVC, LONG aPid)
 {
-    LogRel(("deregisterVBoxSVC: aVBoxSVC=%p aPid=%u (%#x)\n", (IVBoxSVCRegistration *)aVBoxSVC, aPid, aPid));
+    LogRel(("deregisterVBoxSVC: aPid=%u (%#x)\n", aPid, aPid));
     HRESULT hrc;
     if (RT_VALID_PTR(aVBoxSVC))
@@ -543,6 +543,5 @@
                 }
                 else
-                    LogRel(("deregisterVBoxSVC: not the choosen one (%p != %p)\n",
-                            (IVBoxSVCRegistration *)aVBoxSVC, (IVBoxSVCRegistration *)pUserData->m_ptrTheChosenOne));
+                    LogRel(("deregisterVBoxSVC: not the chosen one\n"));
                 pUserData->i_unlock();
                 pUserData->i_release();
@@ -957,5 +956,5 @@
                     }
                 if (cRemoved != 1)
-                    LogRel(("i_watcherThreadProc/#%u: Warning! cRemoved=%u pUserData=%p\n", pThis->iWatcher, cRemoved, pUserData));
+                    LogRel(("i_watcherThreadProc/#%u: Warning! cRemoved=%u\n", pThis->iWatcher, cRemoved));
             }
             /* Zap the entry in case we assert and leave further up. */
@@ -998,6 +997,6 @@
             DWORD dwExit = 0;
             GetExitCodeProcess(pThis->aHandles[iHandle], &dwExit);
-            LogRel(("i_watcherThreadProc/#%u: %p/%s: PID %u/%#x termination detected: %d (%#x)  [iRev=%u, cur %u]\n",
-                    pThis->iWatcher, pUserData, pUserData->m_strUsername.c_str(), pid, pid, dwExit, dwExit,
+            LogRel(("i_watcherThreadProc/#%u: %s: PID %u/%#x termination detected: %d (%#x)  [iRev=%u, cur %u]\n",
+                    pThis->iWatcher, pUserData->m_strUsername.c_str(), pid, pid, dwExit, dwExit,
                     iRevision, pUserData->m_iTheChosenOneRevision));
 
@@ -1115,6 +1114,6 @@
 
                 BOOL fRc = SetEvent(pWatcher->aHandles[0]);
-                AssertLogRelMsg(fRc, ("SetEvent(%p) failed: %u\n", pWatcher->aHandles[0], GetLastError()));
-                LogRel(("i_watchIt: Added %p/%p to watcher #%u: %RTbool\n", pUserData, hProcess, pWatcher->iWatcher, fRc));
+                AssertLogRelMsg(fRc, ("SetEvent() failed: %u\n", GetLastError()));
+                LogRel(("i_watchIt: Added process to watcher #%u: %RTbool\n", pWatcher->iWatcher, fRc));
 
                 i_incrementClientCount();
@@ -1164,5 +1163,5 @@
                 if (RT_SUCCESS(rc))
                 {
-                    LogRel(("i_watchIt: Created new watcher #%u for %p/%p\n", m_cWatchers, pUserData, hProcess));
+                    LogRel(("i_watchIt: Created new watcher #%u\n", m_cWatchers));
 
                     i_incrementClientCount();