Index: trunk/src/VBox/VMM/VMMAll/APICAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/APICAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/APICAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2016-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2016-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/AllPdbTypeHack.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/AllPdbTypeHack.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/AllPdbTypeHack.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2016-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2016-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/CPUMAllCpuId.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/CPUMAllCpuId.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/CPUMAllCpuId.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2013-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/CPUMAllMsrs.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/CPUMAllMsrs.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/CPUMAllMsrs.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2013-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/DBGFAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/DBGFAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/DBGFAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/DBGFAllBp.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/DBGFAllBp.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/DBGFAllBp.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/DBGFAllTracer.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/DBGFAllTracer.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/DBGFAllTracer.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2020-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2020-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/EMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/EMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/EMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/GCMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/GCMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/GCMAll.cpp	(revision 98103)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2022 Oracle and/or its affiliates.
+ * Copyright (C) 2022-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/GIMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/GIMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/GIMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2014-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/GIMAllHv.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/GIMAllHv.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/GIMAllHv.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2014-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/GIMAllKvm.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/GIMAllKvm.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/GIMAllKvm.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2015-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2015-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/HMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/HMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/HMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/HMSVMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/HMSVMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/HMSVMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2017-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2017-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/HMVMXAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/HMVMXAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/HMVMXAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2018-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2018-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllAImpl.asm
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllAImpl.asm	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllAImpl.asm	(revision 98103)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2011-2022 Oracle and/or its affiliates.
+; Copyright (C) 2011-2023 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllAImplC.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllAImplC.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllAImplC.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllCImpl.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllCImpl.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllCImpl.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllCImplStrInstr.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllCImplStrInstr.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllCImplStrInstr.cpp.h	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllCImplSvmInstr.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllCImplSvmInstr.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllCImplSvmInstr.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllCImplVmxInstr.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllCImplVmxInstr.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllCImplVmxInstr.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructions3DNow.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructions3DNow.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructions3DNow.cpp.h	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsInterpretOnly.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsInterpretOnly.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsInterpretOnly.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsOneByte.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsOneByte.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsOneByte.cpp.h	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsPython.py	(revision 98103)
@@ -13,5 +13,5 @@
 __copyright__ = \
 """
-Copyright (C) 2017-2022 Oracle and/or its affiliates.
+Copyright (C) 2017-2023 Oracle and/or its affiliates.
 
 This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsThree0f38.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsThree0f38.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsThree0f38.cpp.h	(revision 98103)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsThree0f3a.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsThree0f3a.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsThree0f3a.cpp.h	(revision 98103)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsTwoByte0f.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsTwoByte0f.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsTwoByte0f.cpp.h	(revision 98103)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap1.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap1.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap1.cpp.h	(revision 98103)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap2.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap2.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap2.cpp.h	(revision 98103)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap3.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap3.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IEMAllInstructionsVexMap3.cpp.h	(revision 98103)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IOMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IOMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IOMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/IOMAllMmioNew.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IOMAllMmioNew.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/IOMAllMmioNew.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/MMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/MMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/MMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/NEMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/NEMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/NEMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2018-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2018-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/NEMAllNativeTemplate-win.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/NEMAllNativeTemplate-win.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/NEMAllNativeTemplate-win.cpp.h	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2018-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2018-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PDMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PDMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PDMAllCritSect.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllCritSect.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllCritSect.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PDMAllCritSectBoth.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllCritSectBoth.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllCritSectBoth.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PDMAllCritSectRw.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllCritSectRw.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllCritSectRw.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2009-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2009-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PDMAllIommu.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllIommu.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllIommu.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2021-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2021-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PDMAllNetShaper.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllNetShaper.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllNetShaper.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PDMAllQueue.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllQueue.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllQueue.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PDMAllTask.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllTask.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllTask.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2019-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2019-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PGMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PGMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PGMAllBth.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllBth.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllBth.h	(revision 98103)
@@ -12,5 +12,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PGMAllGst.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllGst.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllGst.h	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PGMAllGstSlatEpt.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllGstSlatEpt.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllGstSlatEpt.cpp.h	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2021-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2021-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PGMAllPool.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllPool.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllPool.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/PGMAllShw.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllShw.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllShw.h	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/SELMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/SELMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/SELMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/TMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/TMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/TMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/TMAllCpu.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/TMAllCpu.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/TMAllCpu.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/TMAllReal.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/TMAllReal.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/TMAllReal.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/TMAllVirtual.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/TMAllVirtual.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/TMAllVirtual.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/TRPMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/TRPMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/TRPMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/VMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/VMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/VMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/VMMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/VMMAll.cpp	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/VMMAll.cpp	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/VMMAllA.asm
===================================================================
--- trunk/src/VBox/VMM/VMMAll/VMMAllA.asm	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/VMMAllA.asm	(revision 98103)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2009-2022 Oracle and/or its affiliates.
+; Copyright (C) 2009-2023 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/VMM/VMMAll/VMXAllTemplate.cpp.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/VMXAllTemplate.cpp.h	(revision 98066)
+++ trunk/src/VBox/VMM/VMMAll/VMXAllTemplate.cpp.h	(revision 98103)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2012-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2012-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as