Index: trunk/src/VBox/Main/cbinding/capiidl.xsl
===================================================================
--- trunk/src/VBox/Main/cbinding/capiidl.xsl	(revision 98106)
+++ trunk/src/VBox/Main/cbinding/capiidl.xsl	(revision 98108)
@@ -84,5 +84,5 @@
 
 /*
- * Copyright (C) 2008-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2008-2023 Oracle and/or its affiliates.
  *
  * This file is part of a free software library; you can redistribute
Index: trunk/src/VBox/Main/glue/constants-python.xsl
===================================================================
--- trunk/src/VBox/Main/glue/constants-python.xsl	(revision 98106)
+++ trunk/src/VBox/Main/glue/constants-python.xsl	(revision 98108)
@@ -49,5 +49,5 @@
 __copyright__ = \
 """
-Copyright (C) 2009-2022 Oracle and/or its affiliates.
+Copyright (C) 2009-2023 Oracle and/or its affiliates.
 
 This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/Main/glue/glue-java.xsl
===================================================================
--- trunk/src/VBox/Main/glue/glue-java.xsl	(revision 98106)
+++ trunk/src/VBox/Main/glue/glue-java.xsl	(revision 98108)
@@ -69,5 +69,5 @@
   <xsl:param name="name" />
   <xsl:text>/*
- * Copyright (C) 2010-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2010-2023 Oracle and/or its affiliates.
  *
  * This file is part of a free software library; you can redistribute
Index: trunk/src/VBox/Main/idl/apiwrap-server.xsl
===================================================================
--- trunk/src/VBox/Main/idl/apiwrap-server.xsl	(revision 98106)
+++ trunk/src/VBox/Main/idl/apiwrap-server.xsl	(revision 98108)
@@ -92,5 +92,5 @@
 
 /*
- * Copyright (C) 2010-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2010-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/Main/idl/comimpl.xsl
===================================================================
--- trunk/src/VBox/Main/idl/comimpl.xsl	(revision 98106)
+++ trunk/src/VBox/Main/idl/comimpl.xsl	(revision 98108)
@@ -69,5 +69,5 @@
 
 /*
- * Copyright (C) 2010-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2010-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/Main/idl/stringify-enums.xsl
===================================================================
--- trunk/src/VBox/Main/idl/stringify-enums.xsl	(revision 98106)
+++ trunk/src/VBox/Main/idl/stringify-enums.xsl	(revision 98108)
@@ -67,5 +67,5 @@
 
 /*
- * Copyright (C) 2022 Oracle and/or its affiliates.
+ * Copyright (C) 2022-2023 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/Main/webservice/websrv-php.xsl
===================================================================
--- trunk/src/VBox/Main/webservice/websrv-php.xsl	(revision 98106)
+++ trunk/src/VBox/Main/webservice/websrv-php.xsl	(revision 98108)
@@ -373,5 +373,5 @@
 
 /*
- * Copyright (C) 2008-2022 Oracle and/or its affiliates.
+ * Copyright (C) 2008-2023 Oracle and/or its affiliates.
  *
  * This file is part of a free software library; you can redistribute
Index: trunk/src/VBox/Main/webservice/websrv-python.xsl
===================================================================
--- trunk/src/VBox/Main/webservice/websrv-python.xsl	(revision 98106)
+++ trunk/src/VBox/Main/webservice/websrv-python.xsl	(revision 98108)
@@ -490,5 +490,5 @@
 
 <xsl:template match="/">
-<xsl:text># Copyright (C) 2008-2022 Oracle and/or its affiliates.
+<xsl:text># Copyright (C) 2008-2023 Oracle and/or its affiliates.
 #
 # This file is part of a free software library; you can redistribute
Index: trunk/src/VBox/Main/xml/VirtualBox-settings.xsd
===================================================================
--- trunk/src/VBox/Main/xml/VirtualBox-settings.xsd	(revision 98106)
+++ trunk/src/VBox/Main/xml/VirtualBox-settings.xsd	(revision 98108)
@@ -40,5 +40,5 @@
   <xsd:documentation xml:lang="en">
     Oracle VM VirtualBox Settings Schema (common definitions).
-    Copyright (C) 2004-2022 Oracle and/or its affiliates.
+    Copyright (C) 2004-2023 Oracle and/or its affiliates.
   </xsd:documentation>
 </xsd:annotation>